#define _FILE_OFFSET_BITS 64
#define _LARGEFILE_SOURCE

#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "segyhdr.h"

int readData(FILE *fp, float *data, segyhdr *hdrs, int n1)
{
	size_t nread;
	int i, oneshot, itrace, sx, fldr;
	segyhdr hdr;

	oneshot = 1;
	itrace  = 0;

	nread = fread(&hdr, 1, TRCBYTES, fp);
	if (nread == 0) return 0; /* end of file reached */
	memcpy(&hdrs[0], &hdr, TRCBYTES);

	sx   = hdrs[0].sx;
	fldr = hdrs[0].fldr;
	while (oneshot) {
		nread = fread(&data[itrace*n1], sizeof(float), n1, fp);
		assert (nread == n1);
		itrace++;
		nread = fread(&hdr, 1, TRCBYTES, fp);
		if (nread == 0) break;
		assert(nread == TRCBYTES);
		if ( (sx != hdr.sx) || (fldr != hdr.fldr)) { /* end of shot record */
			fseek( fp, -TRCBYTES, SEEK_CUR );
			break;
		}
		memcpy(&hdrs[itrace], &hdr, TRCBYTES);
	}

	return itrace;
}
